
ALTER SESSION SET CURRENT_SCHEMA = VOTACIONS;
COMMIT;

CREATE OR REPLACE PROCEDURE creacio_joc_proves
IS
  codi number;
  votacio1 number;
  votacio2 number;
  votacio3 number;
  votacio4 number;
  loc number;
  reg number;
  opcio number;
  RSP Varchar2(500);
  cens1 number;
  cens2 number;
  cens3 number;
  cens4 number;
  cens5 number;
  
BEGIN
  -------------------------------------------------------------------------------
  -- Creaci de valors a la taula EstatVotacio
  -------------------------------------------------------------------------------
  INSERT INTO EstatVotacio (codiEstat,nomEstat) VALUES ('E','En edici');
  INSERT INTO EstatVotacio (codiEstat,nomEstat) VALUES ('P','Pendent dobertura');
  INSERT INTO EstatVotacio (codiEstat,nomEstat) VALUES ('O','Oberta');
  INSERT INTO EstatVotacio (codiEstat,nomEstat) VALUES ('F','Finalitzada');

  -------------------------------------------------------------------------------
  -- Creaci de valors a la taula TipusCens 
  -------------------------------------------------------------------------------
  INSERT INTO TipusCens (codiTipus,nomTipus) VALUES ('G','Global');
  INSERT INTO TipusCens (codiTipus,nomTipus) VALUES ('L','Local');
  INSERT INTO TipusCens (codiTipus,nomTipus) VALUES ('R','Regional');
  INSERT INTO TipusCens (codiTipus,nomTipus) VALUES ('N','Nacional');

  -------------------------------------------------------------------------------
  -- Creaci de valors a la taula Pais
  -------------------------------------------------------------------------------
  RSP := altaPais('AT','AUSTRIA');
  RSP := altaPais('BE','BELGIUM');
  RSP := altaPais('BG','BULGARIA');
  RSP := altaPais('CY','CYPRUS');
  RSP := altaPais('CZ','CZECH REPUBLIC');
  RSP := altaPais('DE','GERMANY');
  RSP := altaPais('DK','DENMARK');
  RSP := altaPais('EE','ESTONIA');
  RSP := altaPais('ES','SPAIN');
  RSP := altaPais('FI','FINLAND');
  RSP := altaPais('FR','FRANCE');
  RSP := altaPais('GB','UNITED KINGDOM');
  RSP := altaPais('GR','GREECE');
  RSP := altaPais('HU','HUNGARY');
  RSP := altaPais('IE','IRELAND');
  RSP := altaPais('IT','ITALY');
  RSP := altaPais('LT','LITHUANIA');
  RSP := altaPais('LU','LUXEMBOURG');
  RSP := altaPais('LV','LATVIA');
  RSP := altaPais('MT','MALTA');
  RSP := altaPais('NL','NETHERLANDS');
  RSP := altaPais('PL','POLAND');
  RSP := altaPais('PT','PORTUGAL');
  RSP := altaPais('RO','ROMANIA');
  RSP := altaPais('SE','SWEDEN');
  RSP := altaPais('SI','SLOVENIA');
  RSP := altaPais('SK','SLOVAKIA');
  
  -- creem, modifiquem i esborrem un pas
  RSP := altaPais('ZZ','Pas diferent');
  RSP := modificarPais('ZZ','Pas canviat');
  
  -- no deixa esborrar provoca error perqu hi ha estadstiques
  RSP := altaPais('ZW','Pas a esborrar');
  RSP := baixaPais('ZW');

  -- esborrem les estadstiques
  DELETE FROM Est1
   WHERE codiPais = 'ZW';

  -- ara si l'esborrar
  RSP := baixaPais('ZW');
  
  -- votaci codi 1
  RSP := altaVotacio('ESP 05-GEN-2012', 'Eleccions generals dEspanya 5-Febrer-2012', '05/01/2012', '05/01/2012', '06/01/2012', 'JOSEP PRESI TAULA', 'http://www.elec_esp_2012.html');
  votacio1:=getCodiVotacio('ESP 05-GEN-2012');
  RSP := modificarVotacio(votacio1,'ESP 05-GEN-2012', 'Eleccions generals dEspanya 5-Gener-2012', '05/01/2012', '05/01/2012', '06/01/2012', 'JOAN PRESI TAULA', 'http://www.elec_esp_2012.html', 'O');

  -- votaci codi 2
  RSP := altaVotacio('CAT 10-GEN-2012', 'Eleccions al Parlament de Catalunya 10-Gener-2012', '10/01/2012', '10/01/2012', '11/01/2012', 'JOANA PRESI TAULA', 'http://www.elec_catalunya_2012.html');
  votacio2:=getCodiVotacio('CAT 10-GEN-2012');

  -- votaci codi 3
  RSP := altaVotacio('FRA 12-GEN-2012', 'Referendum sortida Frana CEE 12-Gener-2012', '12/01/2012', '12/01/2012', '13/01/2012', 'FRANOIS PRESI TAULA', 'http://www.ref_france_cee_2012.html');
  votacio3:=getCodiVotacio('FRA 12-GEN-2012');
  
  -- votaci codi 4
  RSP := altaVotacio('GUERRA IRAQ 2012', 'Entrar en guerra amb Iraq 2012', '01/01/2012', '10/01/2012', '12/01/2012', 'ANGELA PRESI TAULA', 'http://www.guerra_iraq_2012.html');
  votacio4:=getCodiVotacio('GUERRA IRAQ 2012');


  -- creem 52 regions i 52 localitats
  FOR i IN 1 .. 52 LOOP
    RSP := altaRegio('Regi ' || i);
    RSP := altaLocalitat('Localitat ' || i);
  END LOOP;

  -- modifiquem una regi i una localitat
  reg := getCodiRegio('Regi 51');
  RSP := modificarRegio(reg,' Regi diferent');
  
  loc := getCodiLocalitat('Localitat 51');
  RSP := modificarLocalitat(loc, 'Localitat diferent');

  -- esborrem una regi i una localitat
  reg := getCodiRegio('Regi 52');
  RSP := baixaRegio(reg);
  loc := getCodiLocalitat('Localitat 52');
  RSP := baixaLocalitat(loc);

  -- genera cens codi 1
  RSP := altaCens('Global', NULL, NULL, NULL, 'G');
  cens1 := getCodiCens('Global');

  -- genera cens codi 2 per espanya
  RSP := altaCens('Pas Espanya', 'ES', NULL, NULL, 'N');
  cens2 := getCodiCens('Pas Espanya');
  
  -- genera cens codi 3 regi 1
  reg := getCodiRegio('Regi 1');
  RSP := altaCens('Regi Catalunya', 'ES', reg, NULL, 'R');
  cens3 := getCodiCens('Regi Catalunya');

  -- genera cens codi 4 localitat 1
  loc := getCodiLocalitat('Localitat 1');
  RSP := altaCens('Localitat 1', 'ES', reg, loc, 'L');
  cens4 := getCodiCens('Localitat 1');

  -- genera cens codi 5 per frana
  RSP := altaCens('Pas Frana', 'FR', NULL, NULL, 'N');
  cens5 := getCodiCens('Pas Frana');
  
  -- creem 1000 ciutadans a les 5 primeres regions i 5 localitats i amb una edat aleatoria entre 18 i 78
  FOR i IN 1 .. 5 LOOP

    -- busquem els codis de localitat i regi
    loc := getCodiLocalitat('Localitat ' || i);
    reg := getCodiRegio('Regi ' || i);

    FOR j IN 1 .. 1000 LOOP   
     
      -- creem el ciutad
      codi := (i*10000)+j; 
      RSP := altaCiutada(codi, 'ES', reg, loc, TRUNC(18 + (DBMS_RANDOM.VALUE * 60)));

      -- el posem al cens global
      RSP := altaCensCiutada(cens1, codi);

      -- els que el codi est entre 10000 i 20000 els posem als altres cens generats d'espanya
      IF i=1 THEN
        RSP := altaCensCiutada(cens2, codi);
        RSP := altaCensCiutada(cens3, codi);
        RSP := altaCensCiutada(cens4, codi);
      END IF;

      -- els que el codi est entre 30000 i 40000 els posem al cens de frana
      IF i=3 THEN
        RSP := altaCensCiutada(cens5, codi);
      END IF;
    
    END LOOP;
  END LOOP;


  -- Votaci 1

  -- creem el cens de la votaci
  RSP := altaCensVotacio(cens2,votacio1);
  
  -- crrem les opcions a votar
  RSP := altaOpcio('CIU',votacio1);
  RSP := altaOpcio('PSC',votacio1);
  RSP := altaOpcio('PP',votacio1);
  RSP := altaOpcio('PNV',votacio1);
  
  
  -- creem els vots
  opcio := getCodiOpcio(votacio1,'CIU');
  FOR j IN 1 .. 200 LOOP
    codi:=10000+j;
    RSP := altaVot(codi,votacio1,opcio);
  END LOOP;

  opcio := getCodiOpcio(votacio1,'PSC');
  FOR j IN 201 .. 300 LOOP
    codi:=10000+j;
    RSP := altaVot(codi,votacio1,opcio);
  END LOOP;

  opcio := getCodiOpcio(votacio1,'PP');
  FOR j IN 501 .. 955 LOOP
    codi:=10000+j;
    RSP := altaVot(codi,votacio1,opcio);
  END LOOP;

  opcio := getCodiOpcio(votacio1,'PNV');
  FOR j IN 956 .. 999 LOOP
    codi:=10000+j;
    RSP := altaVot(codi,votacio1,opcio);
  END LOOP;
 
  -- Posem la votaci com a finalitzada perqu s'actualitzin les estadstiques
  RSP := canviEstatVotacio(votacio1,'F');


  -- Votaci 2

  -- creem el cens de la votaci
  RSP := altaCensVotacio(cens3,votacio2);
  
  -- crrem les opcions a votar
  RSP := altaOpcio('CIU',votacio2);
  RSP := altaOpcio('PSC',votacio2);
  RSP := altaOpcio('ERC',votacio2);
  
  
  -- creem els vots
  opcio := getCodiOpcio(votacio2,'CIU');
  FOR j IN 1 .. 250 LOOP
    codi:=10000+j;
    RSP := altaVot(codi,votacio2,opcio);
  END LOOP;

  opcio := getCodiOpcio(votacio2,'PSC');
  FOR j IN 251 .. 400 LOOP
    codi:=10000+j;
    RSP := altaVot(codi,votacio2,opcio);
  END LOOP;

  opcio := getCodiOpcio(votacio2,'ERC');
  FOR j IN 401 .. 575 LOOP
    codi:=10000+j;
    RSP := altaVot(codi,votacio2,opcio);
  END LOOP;

  -- Posem la votaci com a finalitzada perqu s'actualitzin les estadstiques
  RSP := canviEstatVotacio(votacio2,'F');



  -- Votaci 3

  -- creem el cens de la votaci
  RSP := altaCensVotacio(cens5,votacio3);
  
  -- crrem les opcions a votar
  RSP := altaOpcio('SI',votacio3);
  RSP := altaOpcio('NO',votacio3);
  
  
  -- creem els vots
  opcio := getCodiOpcio(votacio3,'SI');
  FOR j IN 1 .. 600 LOOP
    codi:=30000+j;
    RSP := altaVot(codi,votacio3,opcio);
  END LOOP;

  opcio := getCodiOpcio(votacio3,'NO');
  FOR j IN 601 .. 800 LOOP
    codi:=30000+j;
    RSP := altaVot(codi,votacio3,opcio);
  END LOOP;

  -- Posem la votaci com a finalitzada perqu s'actualitzin les estadstiques
  RSP := canviEstatVotacio(votacio3,'F');


  -- Votaci 4

  -- creem el cens de la votaci
  RSP := altaCensVotacio(cens1,votacio4);
  
  -- crrem les opcions a votar
  RSP := altaOpcio('SI',votacio4);
  RSP := altaOpcio('NO',votacio4);
  
  
  -- creem els vots
  opcio := getCodiOpcio(votacio4,'SI');
  FOR j IN 1 .. 100 LOOP
    codi:=10000+j;
    RSP := altaVot(codi,votacio4,opcio);
    codi:=20000+j;
    RSP := altaVot(codi,votacio4,opcio);
    codi:=30000+j;
    RSP := altaVot(codi,votacio4,opcio);
  END LOOP;

  opcio := getCodiOpcio(votacio4,'NO');
  FOR j IN 101 .. 900 LOOP
    codi:=10000+j;
    RSP := altaVot(codi,votacio4,opcio);
    codi:=20000+j;
    RSP := altaVot(codi,votacio4,opcio);
    codi:=30000+j;
    RSP := altaVot(codi,votacio4,opcio);
  END LOOP;

  -- Posem la votaci com a finalitzada perqu s'actualitzin les estadstiques
  RSP := canviEstatVotacio(votacio4,'F');


END;
