
ALTER SESSION SET CURRENT_SCHEMA = VOTACIONS;
COMMIT;

CREATE OR REPLACE PROCEDURE creacio_joc_proves_est
IS
  cens number; 

BEGIN
  -------------------------------------------------------------------------------
  -- Estadstica 1. Votacions finalitzades per pas i any
  -------------------------------------------------------------------------------
  select estVotacionsPaisAny('ES',2012) from DUAL;

  -------------------------------------------------------------------------------
  -- Estadstica 2. % de participaci per cens i any
  -------------------------------------------------------------------------------
  cens := getCodiCens('Pas Espanya');
  select estParticipacioCensAny(cens,2012) from DUAL;

  -------------------------------------------------------------------------------
  -- Estadstica 3. Votacions associades a cens i any
  -------------------------------------------------------------------------------
  select estVotacionsCensAny(cens,2012) from DUAL;

  -------------------------------------------------------------------------------
  -- Estadstica 4. Votaci amb ms participaci de l'any
  -------------------------------------------------------------------------------
  select estVotacioMesParticipAny(2012) from DUAL;

  -------------------------------------------------------------------------------
  -- Estadstica 5. Localitat on ms han votat per any
  -------------------------------------------------------------------------------
  select estLocalitatMesVotsAny(2012) from DUAL;

  -------------------------------------------------------------------------------
  -- Estadstica 6. % ciutadans que mai ha votat per any
  -------------------------------------------------------------------------------
  select estPercentMaiVotatAny(2012) from DUAL;

  -------------------------------------------------------------------------------
  -- Estadstica 7. Votaci que ha tingut ms participaci
  -------------------------------------------------------------------------------
  select estVotacioMesParticip from DUAL;

  -------------------------------------------------------------------------------
  -- Estadstica 8. Votaci amb ms diferncia entre opcions ms i menys votada
  -------------------------------------------------------------------------------
  select estVotacioMesDif from DUAL;

  -------------------------------------------------------------------------------
  -- Estadstica 9. Votaci amb menys diferncia entre opcions ms i menys votada
  -------------------------------------------------------------------------------
  select estVotacioMenysDif from DUAL;

  -------------------------------------------------------------------------------
  -- Estadstica 10. Mxim nombre de votacions i pas d'una persona
  -------------------------------------------------------------------------------
  select estMaxVotacionsUnCiutada,estPaisMaxVotacionsUnCiutada from DUAL;


END;
