
ALTER SESSION SET CURRENT_SCHEMA = VOTACIONS;
COMMIT;

--------------------------------------------------------------------------------
-- gravarLog
--
-- Procediment per guardar el log dels diferents procediments quan s'executen.
-- La data i la hora l'agafa del sistema
--------------------------------------------------------------------------------
CREATE OR REPLACE PROCEDURE gravarLog (
  p_nomProcedEmmagatzemat IN RegistreLog.nomProcedEmmagatzemat%TYPE,
  p_parametresEntrada IN RegistreLog.parametresEntrada%TYPE,
  p_RSP IN RegistreLog.RSP%TYPE
)
IS
  PRAGMA AUTONOMOUS_TRANSACTION;
  dataExec RegistreLog.dataExecucio%TYPE;
BEGIN
  -- Agafem la data del sistema
  dataExec := SYSDATE;

  -- Inserim el registre a la taula de log amb els parmetres passats
  INSERT INTO RegistreLog (nomProcedEmmagatzemat, parametresEntrada, dataExecucio, RSP)
    VALUES (p_nomProcedEmmagatzemat, p_parametresEntrada, dataExec, p_RSP);

  -- Ja que hem posat el Pragma perqu l'execuci sigui independent
  --   fem un commit per tancar la transacci
  COMMIT;
END;


CREATE OR REPLACE PUBLIC SYNONYM gravarLog FOR gravarLog;

GRANT EXECUTE ON gravarLog TO PUBLIC;
